<!DOCTYPE html>
<html lang="en">

<head>
    <title>Create order</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
        <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
        <div class="col-sm-4">
            <select id="select-size" class="form-control">
                <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
                <option value="S"> Nhỏ</option>
                <option value="M"> Vừa</option>
                <option value="L"> Lớn</option>
            </select>
        </div>
        <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
        <div class="col-sm-4">
            <select class="form-control" id="select-drink">
                <option value="NOT_SELECT_DRINK"> Chọn đồ uống</option>
                <option value="COCA"> Cocacola</option>
                <option value="PEPSI"> Pepsi</option>
                <option value="LAVIE"> Lavie</option>
                <option value="TRATAC"> Tra tac</option>
                <option value="TRASUA"> Tra sua</option>

            </select>
        </div>
    </div>
    <div class="form-group row">
        <label class="col-sm-2 col-form-label">Mã voucher</label>
        <div class="col-sm-4">
            <input type="text" id="input-voucher" class="form-control" placeholder="Voucher ID (mã voucher)">
        </div>
        <label class="col-sm-2 col-form-label">Loại pizza</label>
        <div class="col-sm-4">
            <select id="select-pizza" class="form-control">
                <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
                <option value="Seafood"> Hải sản</option>
                <option value="Hawaii"> Ha wai </option>
                <option value="Bacon"> Thịt hun khói </option>
            </select>
        </div>
    </div>
    <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-4">
            <input type="text" id="input-fullname" class="form-control" placeholder="Họ và tên">
        </div>
        <label for="" class="col-sm-2 col-form-label">Email</label>
        <div class="col-sm-4">
            <input type="email" id="input-email" class="form-control" placeholder="Email">
        </div>
    </div>
    <div class="form-group row">
        <label class="col-sm-2 col-form-label">Số điện thoại</label>
        <div class="col-sm-4">
            <input type="text" id="input-mobile" class="form-control" placeholder="Số điện thoại">
        </div>
        <label class="col-sm-2 col-form-label"> Địa chỉ</label>
        <div class="col-sm-4">
            <input type="text" id="input-adress" class="form-control" placeholder="Địa chỉ">
        </div>
    </div>
    <div class="form-group row">
        <label class="col-sm-2 col-form-label">Lời nhắn</label>
        <div class="col-sm-10">
            <textarea id="input-message" class="form-control" placeholder="Lời nhắn"> </textarea>
        </div>

        <div class="form-group text-right">
            <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
        </div>
    </div>
</body>

</html>
<script>
    "use strict";

    /*** REGION 1 - Global variables ***/
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    /*** REGION 2 - Event handlers ***/
    function onBtnCreateOrderClick() {
        console.log("Nút Create Order được ấn");

        const orderObject = {
            kichCo: "",
            duongKinh: 0,
            suon: 0,
            salad: 0,
            loaiPizza: "",
            idVoucher: "",
            idLoaiNuocUong: "",
            soLuongNuoc: 0,
            hoTen: "",
            thanhTien: "",
            email: "",
            soDienThoai: "",
            diaChi: "",
            loiNhan: ""
        };

        // Bước 1: Đọc dữ liệu
        readDataInput(orderObject);

        // Ghi ra console để kiểm tra dữ liệu đã được đọc
        console.log(orderObject);

        // Bước 2: Validate dữ liệu
        if (!validateDataInput(orderObject)) {
            return;
        }

        // Bước 3: Gọi API để gửi request
        const xmlHttp = new XMLHttpRequest();
        callApiCreateOrder(xmlHttp, orderObject);

        // Bước 4: Xử lý hiển thị sau khi request thành công
        xmlHttp.onreadystatechange = function () {
            if (this.readyState === gREQUEST_READY_STATUS_FINISH_AND_OK && this.status === gREQUEST_STATUS_OK) {
                handleCreateOrderResponse(xmlHttp);
            }
        };
    }

    /*** REGION 3 - Common functions ***/
    function readDataInput(orderObject) {
        const selectComboSizeElement = document.getElementById("select-size");
        const selectDrinkElement = document.getElementById("select-drink");
        const voucherElement = document.getElementById("input-voucher");
        const selectPizzaElement = document.getElementById("select-pizza");
        const fullNameElement = document.getElementById("input-fullname");
        const emailElement = document.getElementById("input-email");
        const mobileElement = document.getElementById("input-mobile");
        const addressElement = document.getElementById("input-adress");
        const messageElement = document.getElementById("input-message");

        orderObject.kichCo = selectComboSizeElement.value;
        orderObject.idLoaiNuocUong = selectDrinkElement.value;
        orderObject.soLuongNuoc = selectDrinkElement.value;
        orderObject.idVoucher = voucherElement.value.trim();
        orderObject.loaiPizza = selectPizzaElement.value;
        orderObject.hoTen = fullNameElement.value.trim();
        orderObject.email = emailElement.value.trim();
        orderObject.soDienThoai = mobileElement.value.trim();
        orderObject.diaChi = addressElement.value.trim();
        orderObject.loiNhan = messageElement.value.trim();

        if (orderObject.kichCo === "S") {
            orderObject.duongKinh = 20;
            orderObject.suon = 2;
            orderObject.salad = 200;
            orderObject.soLuongNuoc = 2;
            orderObject.thanhTien = "150000";
        } else if (orderObject.kichCo === "M") {
            orderObject.duongKinh = 24;
            orderObject.suon = 4;
            orderObject.salad = 300;
            orderObject.soLuongNuoc = 4;
            orderObject.thanhTien = "250000";
        } else if (orderObject.kichCo === "L") {
            orderObject.duongKinh = 30;
            orderObject.suon = 6;
            orderObject.salad = 400;
            orderObject.soLuongNuoc = 6;
            orderObject.thanhTien = "350000";
        }
    }

    function validateDataInput(orderObject) {
        // Kiểm tra các trường bắt buộc
        if (
            orderObject.kichCo === "" ||
            orderObject.loaiPizza === "" ||
            orderObject.hoTen === "" ||
            orderObject.email === "" ||
            orderObject.soDienThoai === "" ||
            orderObject.diaChi === ""
        ) {
            alert("Vui lòng điền đầy đủ thông tin bắt buộc!");
            return false;
        }

        // Kiểm tra định dạng email
        const emailPattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (!emailPattern.test(orderObject.email)) {
            alert("Vui lòng nhập đúng định dạng email!");
            return false;
        }

        // Kiểm tra định dạng số điện thoại
        const phonePattern = /(84|0[3|5|7|8|9])+([0-9]{8})\b/;
        if (!phonePattern.test(orderObject.soDienThoai)) {
            alert("Vui lòng nhập đúng định dạng số điện thoại!");
            return false;
        }

        return true;
    }

    function callApiCreateOrder(xmlHttp, orderObject) {
        xmlHttp.open("POST", gBASE_URL, true);
        xmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");

        const jsonData = JSON.stringify(orderObject);
        xmlHttp.send(jsonData);
    }

    function handleCreateOrderResponse(xmlHttp) {
        const response = JSON.parse(xmlHttp.responseText);

        if (xmlHttp.status === gREQUEST_CREATE_SUCCESS) {
            alert("Đặt hàng thành công! Mã đơn hàng của bạn là: " + response.id);
            window.location.href = "indexListView.html";
        } else {
            alert("Đặt hàng không thành công. Vui lòng thử lại sau!");
        }
    }




</script>